=== Tests/RunCMake/FileAPI/interface/CMakeLists.txt ===
project(Interface)
add_library(iface_none INTERFACE)
add_library(iface_srcs INTERFACE ../empty.c)
